place 0h

; Utilizao dos registos:
; R1  Nmero a factorizar
; R2  Divisor (para testar se N  mltiplo de R2)
; R3  Registo auxiliar (porque o MOD destri o primeiro operando)
; R4  Contador do nmero de factores
; R5  Base da zona de memria onde colocar os factores

N	EQU	60		; nmero a factorizar
base	EQU	1000H		; base da zona de memria onde colocar os factores

incio:	MOV	R1, N		; inicializa registo com nmero a factorizar
	MOV	R4, 0		; inicializa contador do nmero de factores
	CMP	R1, 1		; v se N  inferior a 1
	JLT	invlido	; se for o caso sai logo com R4=0 (no factorizvel)
	MOV	R5, base	; inicializa registo com base da zona de memria 
				; onde colocar os factores
deNovo:	MOV	R2, 2		; divisor (primeiro valor a testar: 2)
maisUm:	MOV	R3, R1		; cpia do valor a factorizar (MOD destri o 
									; 1 operando)
	MOD	R3, R2		; resto da diviso do nmero pelo divisor em teste
	JNZ	prximo		; se no for divisvel, vai testar o prximo divisor
	DIV	R1, R2		; factor encontrado. Tira esse factor do nmero
	MOV	[R5 + R4], R2	; armazena o factor na zona de memria
	ADD	R4, 2		; contabiliza o factor encontrado
	JMP	deNovo		; recomea procura de factores
prximo:CMP	R1,1
	JZ     acabou 
	ADD	R2, 1		; obtm o prximo divisor a testar
	CMP	R2, R1		; mas s o vai testar se 
	JLE	maisUm		;  no for superior ao prprio nmero a factorizar
acabou:	CMP	R4, 2		; acabou. Se s se encontrou um factor, 
	JZ	Primo		;  ento o nmero era primo
noPrimo: JMP	noPrimo	; aqui h vrios factores (R4>1)
Primo:	  JMP	Primo		; se chegar aqui, N  primo (R4=1)
invlido:	JMP	invlido			; se chegar aqui, N no  factorizvel (R4=0)
